# CKEditor

CKEditor 的 [ola-ui build](http://git.jd.com/ola-team/CK5-build-ola)

## 示例

  <demo src="basic.jsx" title="基础用法"></demo>
  
## API

### Editor

| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| config | [ckeditor 配置](https://ckeditor.com/docs/ckeditor5/latest/api/module_core_editor_editorconfig-EditorConfig.html) | object | - |
| data | ckeditor 渲染的内容 | string | - |
| readonly | 只读模式 | boolean | false |
| imgUploadUrl | 图片上传路径 | string | - |
| onInit | 初始化回调 | function(editor) | - |
| onChange | 数据变化回调 | Function(event, editor) | - |
| uploadAdapter | 自定义 [UploadAdapter](https://ckeditor.com/docs/ckeditor5/latest/api/module_upload_filerepository-UploadAdapter.html) | Function(event, editor) | - |

### ImageUpload

该组件内置了图片上传的适配器实现，使用该实现需配置 `imgUploadUrl`，并且对服务器端有如下约束:

1. 使用如下签名的方法结束文件:

  ```java
  public Result imgUpload(@RequestParam("file") MultipartFile file);
  ```
  
2. 返回的数据中需包含 `url` 字段，指向上传后图片的完整访问地址

  ```java
  result.addResult("url", "http://storage.jd.com/ola-ui/img/403_3x.png");
  ```
  
如果有特殊需求，请自行实现 `UploadAdapter`

```javascript
class UploadAdapter {
  constructor(loader, config) {
    this.loader = loader;
    this.config = config;
  }

  upload() {
    // upload
  }
  
  abort() {
    // abort
  }
}
```
### CKEditor.Output

用于输出的组件

| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| content | ckeditor 渲染的内容 | string | - |

### Tips

1. ck5 默认为内容自适应高度的编辑区，如果需要设置，请参考 (https://stackoverflow.com/questions/46559354/how-to-set-the-height-of-ckeditor-5-classic-editor)

