'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _olaToolkit = require('ola-toolkit');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var UploadAdapter = function () {
  function UploadAdapter(loader, config) {
    (0, _classCallCheck3.default)(this, UploadAdapter);

    this.loader = loader;
    this.config = config;
  }

  (0, _createClass3.default)(UploadAdapter, [{
    key: 'upload',
    value: function upload() {
      var _this = this;

      var loader = this.loader;
      var imgUploadUrl = this.config.imgUploadUrl;

      var file = this.loader.file;

      return new _promise2.default(function (resolve, reject) {
        _olaToolkit.Ajax.post({
          turnoffAdaptor: true,
          url: imgUploadUrl,
          attach: [{
            key: 'file',
            value: file
          }],
          onProgress: function onProgress(_ref) {
            var loaded = _ref.loaded,
                total = _ref.total;

            loader.uploadTotal = total;
            loader.uploaded = loaded;
          }
        }).then(function (rsp) {
          resolve({
            'default': rsp.url
          });
        }).catch(function (e) {
          reject(e.msg);
        });

        _this.abort = function () {
          reject('');
        };
      });
    }
  }, {
    key: 'abort',
    value: function abort() {
      // Reject promise returned from upload() method.
      // server.abortUpload();
    }
  }]);
  return UploadAdapter;
}();

exports.default = UploadAdapter;
module.exports = exports['default'];