import React, {Component} from 'react';
import {Checkbox, CKEditor} from 'ola-ui';

export default class Basic extends Component {

  state = {
    data: "<p>Hello from CKEditor 5!</p>",
    readonly: false,
  };

  render() {
    const {data, readonly} = this.state;

    return (
      <div>

        <div style={{marginBottom: 20}}>
          <Checkbox checked={readonly} onChange={(e) => {
            this.setState({readonly: e.target.checked});
          }}>readonly</Checkbox>
        </div>

        <CKEditor
          readonly={readonly}
          data={data}
          onInit={editor => {
            // You can store the "editor" and use when it is needed.
            console.log('Editor is ready to use!', editor);
          }}
          onChange={(event, editor) => {
            const data = editor.getData();
            this.setState({
              data
            });
            console.log({event, editor, data});
          }}

          imgUploadUrl={'//localhost:8079/imgUpload/mock'}
        />

        <br/><br/>
        <h3>Code:</h3>
        <pre style={{border: '1px solid #ccc', padding: 10}}>
          <code style={{whiteSpace: 'pre-wrap'}}>{data}</code>
        </pre>

        <h3>Rendered:</h3>
        <CKEditor.Output content={data}/>
      </div>
    )
  }
}
